/* coolirisOverlay.js -- Rahul Jonna 2006 CoolIris, Inc. */



function gBookmarks_AddEventHandlers()
{
//	gBManager.refreshBookmarks();

	 //show the option on any page 
    if (document.getElementById("contentAreaContextMenu") != null)
		document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", gBookmarks_onContextMenuPopup, false);
    
	
}

function gBookmarks_ShowPopup()
{
	var index = -1;
	var isLogged = gBManager.checkLogin();
	gBMDump("login = " + isLogged);	
	gBManager.isLoggedIn = isLogged;
	if (isLogged)
	{
		if (gBManager.arrAllBookmarks != null)
		{
			index = gBManager.isExists(getBrowser().currentURI.spec);
			if (index != -1)
			{
				gBManager.curIndex = index;
				//change the menuitem values
				document.getElementById("gbookmarks-addbookmark").hidden = true;
				document.getElementById("gbookmarks-editbookmark").hidden = false;
				document.getElementById("gbookmarks-removebookmark").hidden = false;
			}
		}
		else
		{
			gBManager.refreshBookmarks();
		}
		if (index == -1)
		{
			document.getElementById("gbookmarks-addbookmark").hidden = false;
			document.getElementById("gbookmarks-editbookmark").hidden = true;
			document.getElementById("gbookmarks-removebookmark").hidden = true;
		}	
		document.getElementById("gbookmarks-login").hidden = true;
		document.getElementById("gbookmarks-options").hidden = false;
		document.getElementById("gbookmarks-seperator").hidden = false;
		document.getElementById("gbookmarks-refresh").hidden = false;
		document.getElementById("gbookmarks-managebookmark").hidden = false;
	}
	else
	{
		var autoSignIn = (gbmPrefHandler.getPref(gbmPrefNames.prefAutoSign, "char") == "true") ? true : false;
		if (autoSignIn)
		{
			gBManager.doLogin(true);
			return;
		}
		
		document.getElementById("gbookmarks-addbookmark").hidden = true;
		document.getElementById("gbookmarks-editbookmark").hidden = true;
		document.getElementById("gbookmarks-removebookmark").hidden = true;
		document.getElementById("gbookmarks-managebookmark").hidden = true;
		document.getElementById("gbookmarks-refresh").hidden = true;
		document.getElementById("gbookmarks-seperator").hidden = true;
		
		document.getElementById("gbookmarks-login").hidden = false;
		document.getElementById("gbookmarks-options").hidden = false;
		gBManager.removeBookmarkMenus();
	}
}




function gBookmarks_onContextMenuPopup()
{
	var  gBookmarks_ContextMenu = new gbm_nsNodeType();
	gBookmarks_ContextMenu.getNodeType();
    gBookmarks_ContextMenu.isContentSelected = gBookmarks_ContextMenu.isContentSelection();
    gBMDump(gBookmarks_ContextMenu.isContentSelected + ", " + gBookmarks_ContextMenu.onLink  + "," + gBookmarks_ContextMenu.onTextInput);
	gBookmarks_ContextMenu.showItem( "contextGBookmarks", (!(gBookmarks_ContextMenu.isContentSelected || gBookmarks_ContextMenu.onTextInput) || gBookmarks_ContextMenu.onLink) );
	if (gBookmarks_ContextMenu.onLink)
	{
		gBManager.isLink = gBookmarks_ContextMenu.onLink;
		gBManager.selectedUrl = gBookmarks_ContextMenu.linkURL;
		gBManager.selectedText = gBookmarks_ContextMenu.linkText(); 
	}
	else
		gBManager.isLink = false;
}



function gBookmarks_LoadBookmark(gbmItem)
{
	url = gbmItem.getAttribute("url");
	var currBlank = (getBrowser() && 
		(getBrowser().mCurrentTab.linkedBrowser && 
		(getBrowser().mCurrentTab.linkedBrowser.contentDocument.location == "about:blank")) ||
		(!getBrowser().mCurrentTab.linkedBrowser && 
		(getBrowser().mCurrentTab.label == "(Untitled)")));
		if (currBlank) 
			{
				getBrowser().selectedTab = loadURI(url);
			} else {
				getBrowser().selectedTab = getBrowser().addTab(url);
			}
	//loadOneOrMoreURIs(url);
}

function gBookmarks_OpenInTab(url, selected)
{
	try
	{
		if (selected)
			getBrowser().selectedTab = getBrowser().addTab(url);
		else
			getBrowser().addTab(url);
	}
	catch (ex)
	{
		alert(ex);
	}
}

function gBookmarks (url, bmTitle, label, id, timestamp)
{
	this.url = url;
	this.bmTitle = bmTitle;
	this.label = label;
	this.id = id;
	this.timestamp = timestamp;
}

var gBManager =
{
	arrLabels : null,
	arrAllBookmarks : null,
	curIndex : -1,
	sid : null,
	isLoggedIn : false,
	sort : "title",
	selectedUrl : "",
	selectedText : "",
	isLink	: false,
	isRefreshed : false,
	
	bkmkTitle   :  "",
	bkmkLabel   : "",
	bkmkUrl     : "",

	isExists : function(url)
	{
		var found = -1;
		//gBMDump(this.arrAllBookmarks.length)
		if (this.arrAllBookmarks != null)
		{
			for (var i = 0; i < this.arrAllBookmarks.length; i++)
			{
				if (this.arrAllBookmarks[i].url == url)
				{
					found = i;
					break;
				}
			}
		}
		return found;
	},
	
	manageBookmarks : function ()
	{
		var url = "http://www.google.com/bookmarks/";
		gBookmarks_OpenInTab(url, true);
	},
	
	showOptions : function()
	{
		window.openDialog("chrome://gbookmarks/content/options.xul", "Preferences", 
					"chrome,centerscreen,modal");
	},
	
	addEditBookmark : function ()
	{
		var isLogged = gBManager.checkLogin();
		if (!isLogged)
		{
			alert("You must be logged in to add bookmarks");
			return;
		}
		if (!gBManager.isRefreshed)
		{
			alert("Refresh your bookmarks once...");
			return;
		}
		var bkmk, bkmkTitle, bkmkLabel = null, how = "Add";
		if (gBManager.isLink)
		{
			bkmk = this.selectedUrl;
			bkmkTitle = this.selectedText;
		}
		else
		{
			bkmk = getBrowser().currentURI.spec;
			bkmkTitle = getBrowser().contentDocument.title;
		}
		var index = gBManager.isExists(bkmk);
		if (index != -1 && gBManager.arrAllBookmarks != null && gBManager.arrAllBookmarks[index] != null)
		{
			bkmkLabel = gBManager.arrAllBookmarks[index].label;		
			how = "Edit";			
		}
		window.openDialog("chrome://gbookmarks/content/gbookmarksAddBookmark.xul", how + " Bookmark", 
					"chrome,centerscreen,modal", how.toLowerCase().toString(), bkmk, bkmkTitle, this.arrLabels, bkmkLabel);
		if (this.bkmkUrl == "")
		    return;
		gBManager.addBookmarkToGoogleBookmarks(this.bkmkUrl, this.bkmkTitle, this.bkmkLabel);
		
		//this.refreshBookmarks();
	},

	addBookmark : function ()
	{
		var bkmk = getBrowser().currentURI.spec;
		var bkmkTitle = getBrowser().contentDocument.title;
		var bkmkLabel = "^";
		
		window.openDialog("chrome://gbookmarks/content/gbookmarksAddBookmark.xul", "Add Bookmark", 
					"chrome,centerscreen,modal", "add", bkmk, bkmkTitle, this.arrLabels, bkmkLabel);
		
		if (this.bkmkUrl == "")
		    return;
		//alert(this.bkmkTitle + ", " + this.bkmkLabel);
		gBManager.addBookmarkToGoogleBookmarks(this.bkmkUrl, this.bkmkTitle, this.bkmkLabel);
		
		//this.refreshBookmarks();
	},
	
	editBookmark : function ()
	{
		if (gBManager.arrAllBookmarks == null || gBManager.arrAllBookmarks[gBManager.curIndex] == null)
			return;
		var bkmk = gBManager.arrAllBookmarks[gBManager.curIndex].url;
		var bkmkTitle = gBManager.arrAllBookmarks[gBManager.curIndex].bmTitle;
		var bkmkLabel = gBManager.arrAllBookmarks[gBManager.curIndex].label;
		
		window.openDialog("chrome://gbookmarks/content/gbookmarksAddBookmark.xul", "Edit Bookmark", 
					"chrome,centerscreen,modal", "edit", bkmk, bkmkTitle, this.arrLabels, bkmkLabel);
		
		if (this.bkmkUrl == "")
		    return;			
		gBManager.addBookmarkToGoogleBookmarks(this.bkmkUrl, this.bkmkTitle, this.bkmkLabel);
		
		//this.refreshBookmarks();
	},

	removeBookmark : function()
	{
		if (gBManager.arrAllBookmarks == null || gBManager.arrAllBookmarks[gBManager.curIndex] == null)
			return;
		try
		{
			var objResp = new WebResponse(0, "");
			var uri = "http://www.google.com/bookmarks/mark";							
			var postData = "dlq=" + gBManager.arrAllBookmarks[gBManager.curIndex].id + "&op=remove";
			objResp = xhttp.doAsyncPost(postData, "", function () { gBManager.refreshBookmarks(); }, uri, "application/xml");

			if (objResp.eId > 0)
				throw objResp.eMesg;

			//gBManager.refreshBookmarks();

		}
		catch (ex)
		{
			alert("Bookmark cannot be removed - " + ex);
		}
		
	},

	addBookmarkToGoogleBookmarks : function (bkmk, bmTitle, labels)
	{
		try
		{
			var objResp = new WebResponse(0, "");
			var uri = "http://www.google.com/bookmarks/mark";							
			url = encodeURIComponent(bkmk);
			bmTitle = encodeURIComponent(bmTitle);
			labels = encodeURIComponent(labels);
			var postData = "q=" + url + "&title=" + bmTitle + "&labels=" + labels;//"bkmk=http%3A%2F%2Fwww.google.com%2Fwebhp%3Fcomplete%3D1%26hl%3Den&title=Google&labels=&a_n1=favicon_url&a_v1=notfound&a_n2=favicon_timestamp&a_v2=" + Math.round((new Date()).valueOf() / 1000) + "&zx=0";// 
			gBMDump(postData);
			var uri = "http://www.google.com/bookmarks/mark";							
			objResp = xhttp.doAsyncPost(postData, "", function () { gBManager.refreshBookmarks(); }, uri, "application/xml");

            var uriLink = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
			uriLink.spec = bkmk;
			
			var imageUri = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
			imageUri.spec = uriLink.scheme + "://" + uriLink.host + "/favicon.ico";
			
			// Make a new nsIURIChecker
			var uriChecker = Components.classes["@mozilla.org/network/urichecker;1"]
							.createInstance()
							.QueryInterface(Components.interfaces.nsIURIChecker);
			// uri creation needs to be localized
			uriChecker.init(imageUri);
			uriChecker.asyncCheck(new gBookmarks_imageRequestObserver("", imageUri, postData, "add"), null);
			
			if (objResp.eId > 0)
				throw objResp.eMesg;
			
		}
		catch (ex)
		{
			alert(ex);
		}
	},

	getResultFromXPath : function(xpathExp, aContextNode)
	{
		try
		{
			var resultType   = XPathResult.ORDERED_NODE_SNAPSHOT_TYPE;
			var nsResolver = document.createNSResolver( aContextNode.ownerDocument == null ? aContextNode.documentElement : aContextNode.ownerDocument.documentElement );
			var expression = aContextNode.createExpression(xpathExp, nsResolver);
			var result = aContextNode.evaluate( xpathExp, aContextNode, nsResolver, resultType, null );
		}
		catch (ex)
		{
			return null;	
		}
		return result;
	},

	refreshBookmarks : function (how)
	{
		var isLogin = gBManager.checkLogin();
		if (!isLogin)
			return;
		else
		{
			//if automatic sign on is present, call doLogin
			var autoSignIn = (gbmPrefHandler.getPref(gbmPrefNames.prefAutoSign, "char") == "true") ? true : false;
			if (autoSignIn)
			{
				var isLogin = gBManager.doLogin(false);
				if (!isLogin)
					return;
			}
		}
		this.removeBookmarkMenus();
		var objResp = new WebResponse(0, "");
		var sortSelectedItem = gbmPrefHandler.getPref(gbmPrefNames.prefSort, "char");
		if (sortSelectedItem == "" || sortSelectedItem == "0")
			this.sort = "date";
		else
			this.sort = "title";
			
		var uri;
		if (this.sort == "title")
			uri = "http://www.google.com/bookmarks/?output=xml&sort=title&num=10000";	
		else
			uri = "http://www.google.com/bookmarks/?output=xml&sort=date&num=10000";	
		gBManager.isRefreshed = true;
		gBMDump(uri);
		objResp = xhttp.doAsyncGetXml("", gBManager.loadBookmarks, uri);
	},

	removeBookmarkMenus : function ()
	{
		gBMDump(this.arrLabels);
		if (this.arrLabels != null)
		{
			var gBMenu = document.getElementById("gbookmarks-menupopup");
			for (var i = 0; i < gBMenu.childNodes.length; i++)
			{
				
				if (gBMenu.childNodes[i].getAttribute("fixed") != "yes")
				{
					gBMDump(gBMenu.childNodes[i].getAttribute("fixed"));
					gBMenu.removeChild(gBMenu.childNodes[i]);
					i--;
				}
			}
		}
		delete this.arrAllBookmarks;
		this.arrAllBookmarks = null;
	},

	loadBookmarks : function (objResp)
	{
		var xmlDoc = objResp.auxObj;
		var gBMenu = document.getElementById("gbookmarks-menupopup");
		
		var resSnapshots = gBManager.getResultFromXPath("//label", xmlDoc);
		var arrLabels = new Array();
		gBManager.arrAllBookmarks = new Array();
		
		for (var i = 0; i < resSnapshots.snapshotLength; i++)
		{
			var found = gBManager.inArray(arrLabels, resSnapshots.snapshotItem(i).textContent);
			if (found == -1 && resSnapshots.snapshotItem(i).textContent.indexOf("^") == -1)
				arrLabels.push(resSnapshots.snapshotItem(i).textContent);
			
		}
		if (gBManager.sort == "title")
		{
			arrLabels.sort(	function (x, y)
							{ 	
								if (x.toString().toLowerCase() < y.toString().toLowerCase())
									return -1;
								else if (x.toString().toLowerCase() > y.toString().toLowerCase())
									return 1;
								return 0; 
							});
		}
		
		gBManager.arrLabels = arrLabels;
		gBManager.arrBMs = new Array();
		
		for (var i = 0; i < arrLabels.length; i++)
		{
			var gbmSubMenus = document.createElement("menu");
			var gbmSubMenusPopup = document.createElement("menupopup");
			gbmSubMenus.setAttribute("label", arrLabels[i]);
			gbmSubMenusPopup.setAttribute("id", "gbmpop-" + arrLabels[i]);
			gbmSubMenus.setAttribute("id", "gbmenu-" + arrLabels[i]);
			gbmSubMenus.setAttribute("container", "true");
			gbmSubMenus.setAttribute("class", "menu-iconic bookmark-item");
			gbmSubMenus.appendChild(gbmSubMenusPopup);
			gBMenu.appendChild(gbmSubMenus);
		}
		
		var gbmNodes = xmlDoc.getElementsByTagName("bookmark");
		for (var i = 0; i < gbmNodes.length; i++)
		{
			var curBookmark = new gBookmarks();
			//curBookmark.label = (gbmNodes[i].getElementsByTagName("label")[0] != null) ?  gbmNodes[i].getElementsByTagName("label")[0].firstChild.nodeValue : "^";
			curBookmark.bmTitle = (gbmNodes[i].getElementsByTagName("title")[0] != null) ?  gbmNodes[i].getElementsByTagName("title")[0].firstChild.nodeValue : "No title";
			curBookmark.url = gbmNodes[i].getElementsByTagName("url")[0].firstChild.nodeValue;
			curBookmark.timestamp = gbmNodes[i].getElementsByTagName("timestamp")[0].firstChild.nodeValue;
			curBookmark.id = gbmNodes[i].getElementsByTagName("id")[0].firstChild.nodeValue;
			
			var gbmItem = document.createElement("menuitem");
			gbmItem.setAttribute("label", curBookmark.bmTitle);
			gbmItem.setAttribute("url", curBookmark.url);
			gbmItem.setAttribute("id", "gbm-" + curBookmark.id);
			gbmItem.setAttribute("statustext", curBookmark.url);
			gbmItem.setAttribute("tooltiptext", "[" + jsBMUtils.getDateString(curBookmark.timestamp) + "] - " + curBookmark.url);
            
			gbmItem.setAttribute("class", "menuitem-iconic bookmark-item");
			
			
			var attributes = gbmNodes[i].getElementsByTagName("attributes")[0];
			if (attributes != null)
			{
			    var attributeNodes = attributes.getElementsByTagName("attribute");
			    for (var m = 0; m < attributeNodes.length; m++)
			    {
			        gBMDump("name = " + attributeNodes[m].getElementsByTagName("name")[0].firstChild.nodeValue +  ", " + attributeNodes[m].getElementsByTagName("value")[0].firstChild.nodeValue);
			        if (attributeNodes[m].getElementsByTagName("name")[0].firstChild.nodeValue == "favicon_url")
			        {
			            if (attributeNodes[m].getElementsByTagName("value")[0].firstChild.nodeValue != "notfound")
			                gbmItem.setAttribute("image", attributeNodes[m].getElementsByTagName("value")[0].firstChild.nodeValue);
			        }
			    } 
			}
			
			
			var arrLabels = new Array();
			for (var k = 0; k < gbmNodes[i].getElementsByTagName("label").length; k++)
			{
			    arrLabels.push(gbmNodes[i].getElementsByTagName("label")[k].firstChild.nodeValue);
			    var gbmSubMenusPopup = document.getElementById("gbmpop-" + gbmNodes[i].getElementsByTagName("label")[k].firstChild.nodeValue);
			    if (gbmSubMenusPopup != null)
			    {
			        var cloneNode = gbmItem.cloneNode(true);
			        cloneNode.addEventListener("click", function (evt) { gBookmarks_LoadBookmark(this, evt)  }, true);
				    gbmSubMenusPopup.appendChild(cloneNode);
			    }    
			}			
			
			curBookmark.label = (arrLabels.length == 0) ? "" : arrLabels.join(",");
			if (arrLabels.length == 0)
			{   
			    gBMDump("idd = " + document.getElementById(curBookmark.id) + ", " + curBookmark.id + ", " + curBookmark.bmTitle + ", " + gbmNodes[i].getElementsByTagName("label").length);
				if (document.getElementById("gbm-" + curBookmark.id) == null)
				{
				    gBMDump("labels = " + curBookmark.label);
				    var cloneNode = gbmItem.cloneNode(true);
			        cloneNode.addEventListener("click", function (evt) { gBookmarks_LoadBookmark(this, evt)  }, true);
					gBMenu.appendChild(cloneNode);
			    }
			}
			
			gBManager.arrAllBookmarks.push(curBookmark);
		}
		//setTimeout(function () { gBManager.setMenuImages() }, 100);
		setTimeout(function () { gBManager.setMenuButtons() }, 100);
	},
	
	inArray : function (arrLabels, text)
	{
		var found = -1;
		for (var i = 0; i < arrLabels.length; i++)
		{
			if (arrLabels[i] == text)
				found = i;
		}
		return found;
	},

	setMenuButtons : function ()
	{
		var index = gBManager.isExists(getBrowser().currentURI.spec);
		if (index != -1)
		{
			gBManager.curIndex = index;
			//change the menuitem values
			document.getElementById("gbookmarks-addbookmark").hidden = true;
			document.getElementById("gbookmarks-editbookmark").hidden = false;
			document.getElementById("gbookmarks-removebookmark").hidden = false;
		}
	},
	
	setMenuImages : function ()
	{
		for (var i = 0; i < gBManager.arrAllBookmarks.length; i++)
		{
			var curBookmark = gBManager.arrAllBookmarks[i];		
			var uriLink = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
			uriLink.spec = curBookmark.url;
			
			var imageUri = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
			imageUri.spec = uriLink.scheme + "://" + uriLink.host + "/favicon.ico";
			
			// Make a new nsIURIChecker
			var uriChecker = Components.classes["@mozilla.org/network/urichecker;1"]
							.createInstance()
							.QueryInterface(Components.interfaces.nsIURIChecker);
			// uri creation needs to be localized
			uriChecker.init(imageUri);
			uriChecker.asyncCheck(new gBookmarks_imageRequestObserver(curBookmark.id, imageUri), null);
						
			
			
			//var gbmItem = document.getElementById(curBookmark.id);
			//gbmItem.setAttribute("image", uriLink.scheme + "://" + uriLink.host + "/favicon.ico");
		}
	},
	
	
	checkLogin : function ()
	{
		var cookieManager = Components.classes["@mozilla.org/cookiemanager;1"]
							.getService(Components.interfaces.nsICookieManager);

		var iter = cookieManager.enumerator;
		var gcookie = -1;
		while (iter.hasMoreElements())
		{
			var cookie = iter.getNext();
			if (cookie instanceof Components.interfaces.nsICookie)
			{
				
				if (cookie.host.indexOf("google.com") != -1)
				{
					//gBMDump("Cookies = " + cookie.host + ", " + cookie.name);
					if (cookie.name == "SID")
					{	
						gcookie = cookie.value;	
					}
				}
			}
		}
		if (gcookie != -1)
		{
			gBManager.sid = gcookie;
			//myDump(gcookie, false);	
			return true;
		}
		else
		{
			return false;
		}
	},
	
	doLogin : function (refresh)
	{
		try
		{
			var autoSignIn = (gbmPrefHandler.getPref(gbmPrefNames.prefAutoSign, "char") == "true") ? true : false;
			if (!autoSignIn && !refresh)
				return false;
			var isLogged = gBManager.isLoggedIn;
			if (isLogged)
			{
				//store the cookie
			}
			var objResp = new WebResponse(0, "");
			var uri = "https://www.google.com/accounts/ServiceLoginAuth";//"https://www.google.com/accounts/LoginAuth";						
			var remember = (gbmPrefHandler.getPref(gbmPrefNames.prefRememberPwd, "char") == "true") ? true : false;
			var userName  = gbmPrefHandler.getPref(gbmPrefNames.prefUserName, "char");
			if (jsBMUtils.trimWhitespace(userName) == "")
			{
				if (remember)
					throw "Login failed! UserName is empty. Set the correct username and password in Options";
				else
				{
					userName = prompt("Please give the username to login");
					if (userName == null)
						return false;
				}
			}
			var passwd = jsBMUtils.getPassword(userName);
			
			if (passwd == "")
			{
				if (remember)
					throw "Login failed! Password is empty. Set the username and password in Options";
				else
				{
					var promptPwd = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService);
                    var objPasswd = {value:""};
                    var objCheck = {value:""};
                    var chkPwd = promptPwd.promptPassword(window, "Password", "Please give the password for " + userName, objPasswd, "", objCheck);
					if (chkPwd == null)
						return false;
					passwd = objPasswd.value;
				}
			}
			var postData = "ltmpl=wsad&ltmplcache=2&continue=https%3A%2F%2Fmail.google.com%2Fmail%2F%3F&rmShown=1&rm=false&passive=true&Email=" + escape(userName) + "&Passwd=" + escape(passwd) + "";
			objResp = xhttp.doSyncPost(postData, "", uri);

			if (objResp.eId > 0)
				throw objResp.eMesg;	
			isLogged = gBManager.checkLogin();
			if (!isLogged)	
				throw "Login failed! check your password...";
			else
			{
				if (!remember)
					alert("Login successful!");
				if (refresh)
					gBManager.refreshBookmarks();
			}
			return true;
		}
		catch (ex)
		{
			alert(ex);
			return false;
		}
	}
}


function gBookmarks_imageRequestObserver (id, imageUri, postData, type)
{
	this.elementId = id;
	this.imageUri = imageUri;
	this.postData = postData;
	this.type = type;
}

gBookmarks_imageRequestObserver.prototype =
{
	// urichecker requires that we have an OnStartRequest even tho it's a nop.
	onStartRequest: function(request, ctxt) { },

	// onStopRequest is where we really handle the status.
	onStopRequest: function(request, ctxt, status)
	{
			//gBMDump("uri checker working - " + status + " , " + this.imageUri.spec);
			if (status == 0)
			{
			    if (this.type == "add")
			    {
			        var uri = "http://www.google.com/bookmarks/mark";	
			        var postData = this.postData +  "&a_n1=favicon_url&a_v1=" + encodeURIComponent(this.imageUri.spec) + "&a_n2=favicon_timestamp&a_v2=" + Math.round((new Date()).valueOf() / 1000);						
			        objResp = xhttp.doAsyncPost(postData, "", null, uri, "application/xml");
			    }
			    else
			    {
				    var gbmItem = document.getElementById(this.elementId);
				    if (gbmItem != null)
					    gbmItem.setAttribute("image", this.imageUri.spec);
				}
			}
	}
}
function test()
{
	alert("A");
}


window.addEventListener("load", gBookmarks_AddEventHandlers, false);

